(ns attendant.server
  (:require
   [com.stuartsierra.component :as component]
   [attendant.handler :refer [make-handler]]
   [ring.adapter.jetty :refer [run-jetty]]
   [ring.middleware.reload :refer [wrap-reload]]))

(defrecord Server [port dev]
  component/Lifecycle
  (start [this]
    (println "starting web server" (when dev "(in dev mode)"))
    (let [handler (make-handler)
          hand (if dev
                 (wrap-reload handler)
                 handler)]
      (assoc this :server
             (run-jetty hand {:port port
                              :join? false}))))
  (stop [this]
    (println "stopping web server")
    (.stop (:server this))
    (.destroy (:server this))
    this))
